optionWin = LibStub("AceGUI-3.0")

local count = 0
local flag = true

local optwin = optionWin:Create("Frame")
optwin:SetTitle("TimeToDeath Options")
optwin:Hide()

local group1 = optionWin:Create("SimpleGroup")
optwin:AddChild(group1)
group1:SetFullWidth(true)
group1:SetLayout("Flow")

-- SLIDER : Must be before select to change its value
local sliderTracked_rate = optionWin:Create("Slider")
sliderTracked_rate:SetLabel("Select percentage to track : ")
sliderTracked_rate:SetSliderValues(0, 1, 0.01)
sliderTracked_rate:SetIsPercent(true)
sliderTracked_rate:SetCallback("OnValueChanged", function(self, callback, value)
	setTracked_rate(value)
end)

local colorTTD = optionWin:Create("ColorPicker")
colorTTD:SetLabel("Timer normal color")
colorTTD:SetHasAlpha(true)
colorTTD:SetCallback("OnValueConfirmed", function(self, callback, r, g, b, a)
	setFontColor(r, g, b, a)
end)

local textTimeToChange = optionWin:Create("EditBox")
textTimeToChange:SetLabel("Choose when the timer change color : ")
textTimeToChange:SetCallback("OnEnterPressed", function(self, callback, value)
	setTimeToChange(tonumber(value))
end)

local colorTimeToChange = optionWin:Create("ColorPicker")
colorTimeToChange:SetLabel("Timer change color")
colorTimeToChange:SetHasAlpha(true)
colorTimeToChange:SetCallback("OnValueConfirmed", function(self, callback, r, g, b, a)
	setChangeFontColor(r, g, b, a)
end)

local sliderSize = optionWin:Create("Slider")
sliderSize:SetLabel("Size of timer : ")
sliderSize:SetSliderValues(0, 200, 1)
sliderSize:SetCallback("OnValueChanged", function(self, callback, value)
	setSizeFrame(value)
end)

local precisionDD = optionWin:Create("Dropdown")
precisionDD:SetLabel("Precision")
precisionDD:SetList({
						[1] = "12",
						[10] = "12.3",
						[100] = "12.34"
					})
precisionDD:SetCallback("OnValueChanged", function(self, callback, key)
	setPrecision(key)
end)

local delButton = optionWin:Create("Button")

local function setDisabled()
	sliderTracked_rate:SetDisabled(true)
	textTimeToChange:SetDisabled(true)
	sliderSize:SetDisabled(true)
	colorTimeToChange:SetDisabled(true)
	colorTTD:SetDisabled(true)
	delButton:SetDisabled(true)
	precisionDD:SetDisabled(true)
end

local function setEnabled()
	sliderTracked_rate:SetDisabled(false)
	textTimeToChange:SetDisabled(false)
	sliderSize:SetDisabled(false)
	colorTimeToChange:SetDisabled(false)
	colorTTD:SetDisabled(false)
	delButton:SetDisabled(false)
	precisionDD:SetDisabled(false)
end

local group2 = optionWin:Create("InlineGroup")
group2:SetFullWidth(true)
group2:SetFullHeight(true)
optwin:AddChild(group2)

local selectTTD = optionWin:Create("Dropdown")
selectTTD:SetLabel("Select timer : ")
selectTTD:SetCallback("OnValueChanged", function(self, callback, key)
	if flag then
		flag = not flag
		setEnabled()
	end
	setIndexTTD(key)
	sliderTracked_rate:SetValue(getTracked_rate())
	colorTTD:SetColor(getFontColor())
	textTimeToChange:SetText(getTimeToChange())
	colorTimeToChange:SetColor(getChangeFontColor())
	sliderSize:SetValue(getSizeFrame())
	precisionDD:SetValue(getPrecision())
end)
selectTTD:SetWidth(150)
group1:AddChild(selectTTD)

delButton:SetText("Delete this timer")
delButton:SetCallback("OnClick", function(...)
	deleteTTD()
	count = 0
	local newList = {}
	for key, value in pairs(selectTTD.list) do
		if key ~= selectTTD:GetValue() then
			newList[key] = value
			if count < key then count = key end
		end
	end
	if #newList == 0 then
		setDisabled()
		flag = not flag
	end
	selectTTD:SetList(newList)
	selectTTD:SetValue(count)
	setIndexTTD(count)
end)

local addButton = optionWin:Create("Button")
addButton:SetText("Add timer")
addButton:SetCallback("OnClick", function(...)
	if flag then
		flag = not flag
		setEnabled()
	end
	count = count + 1
	selectTTD:AddItem(count, "Timer "..count)
	selectTTD:SetValue(count)
	setNewTTD(count)
	setIndexTTD(count)
	sliderTracked_rate:SetValue(0)
	colorTTD:SetColor(1, 1, 1, 1)
	textTimeToChange:SetText(5)
	colorTimeToChange:SetColor(1, 0, 0, 1)
	sliderSize:SetValue(72)
	precisionDD:SetValue(1)
end)
group1:AddChild(addButton)

setDisabled()
group2:AddChild(sliderTracked_rate)
group2:AddChild(colorTTD)
group2:AddChild(textTimeToChange)
group2:AddChild(colorTimeToChange)
group2:AddChild(sliderSize)
group2:AddChild(precisionDD)
group2:AddChild(delButton)

function setListSelect(list)	
	selectTTD:SetList(list)
	if list[1] ~= nil then
		for key, _ in pairs(list) do
			if count < key then count = key end
		end
		selectTTD:SetValue(0)
	end
end

function showOptions()
	optwin:Show()
end